/*trace richtige_kombination*/
predicates
rep
f
muttergruppe_bekannt(integer)
fatergruppe_bekannt(integer)
kindgruppe_bekannt(integer)
alles_knappt(integer,integer)
gruppen_bekannt(integer,integer,integer)
richtige_kombination(integer,integer,integer)
base(integer,integer,integer)
gutchar
gut(integer)
allgemeine_rechnung(integer,integer,integer*,integer*)
rechung(integer,integer,integer,integer*)
mitglied(integer,integer*)

clauses

f:-
    clearwindow,
      gruppen_bekannt(M,K,F),
        rechnung(M,F,K,[]),
          readchar(_).

gruppen_bekannt(M,K,F):-
           makewindow(1,30,30,"  室  ",4,26,10,42),
	     rep,
	      clearwindow,
               muttergruppe_bekannt(M),
                 kindgruppe_bekannt(K),
                   alles_knappt(M,K),
                     fatergruppe_bekannt(F).

muttergruppe_bekannt(Muttergruppe) :- nl,write("  㯯 ஢ : "),
   readint(Muttergruppe).

fatergruppe_bekannt(Fatergruppe) :- nl,write("  㯯 ஢ : "),
   readint(Fatergruppe).


kindgruppe_bekannt(Kindgruppe) :- nl,write("  㯯 ஢ ॡ: "),
   readint(Kindgruppe).

alles_knappt(Muttergruppe,Kindgruppe):-base(_,Muttergruppe,Kindgruppe);
				       base(Muttergruppe,_,Kindgruppe).
alles_knappt(_,_):-makewindow(2,78,78," ! ",15,16,5,62),
    gotowindow(2),
    nl,write("   ⨢稢 !"),
    nl,write(" (    ॡ)."),
    nl,write(" <Enter> -   , <Esc> - ࢠ ணࠬ: "),
    gutchar.

gutchar:-readchar(Ch),
             char_int(Ch,X),gut(X).
gut(X):-X=13,!,
        removewindow(),
        gotowindow(1),
        fail.
gut(X):-X=27,exit.
gut(_):-gutchar.


/*
richtige_kombination(M,F,K):- base(M,F,K),
	    makewindow(2,78,78," ࠢ塞 ! ",15,26,5,42),
	    gotowindow(2),nl,write("      .").

richtige_kombination(M,F,K):- base(F,M,K),
	    makewindow(2,78,78," ࠢ塞 ! ",15,26,5,42),
	    gotowindow(2),nl,write("      .").


richtige_kombination(_,_,_):-
            makewindow(2,78,78," ࠢ塞 ! ",15,26,5,42),
	    gotowindow(2),nl,write("       .").
*/
allgemeine_rechnung(M,K,List,ResList):-
             base(M,ALL,K,),
             allgemeine_rechnung(M,K,[ALL|List],ResList).

allgemeine_rechnung(M,K,List,ResList)):-
             base(ALL,M,K,),
             allgemeine_rechnung(M,K,[ALL|List],ResList).
allgemeine_rechnung(M,K,ResList,ResList).

rechnung(M,F,K,List):-
             allgemeine_rechnung(M,K,List,ResList),
	     mitglied(F,ResList),
             len(X,ResList),
	     gratulation(X).

rechnung(M,F,K,List):-
	    makewindow(2,78,78," ࠢ塞 ! ",15,26,5,42),
	    gotowindow(2),nl,write("       .").


gratulation(X):- 
	    makewindow(2,78,78," ࠢ塞 ! ",15,26,5,42),
	    gotowindow(2),nl,write("      .")
	    nl,write("⭮ 1/"), write(X).




mitglied(R,[R|T]).
mitglied(R,[_|T]):-mitglied(R,T).




base(1,1,1).
base(1,2,1).
base(1,2,2).
base(1,3,1).
base(1,3,3).
base(1,4,2).
base(1,4,3).

base(2,2,1).
base(2,2,2).
base(2,3,1).
base(2,3,2).
base(2,3,3).
base(2,3,4).
base(2,4,2).
base(2,4,3).
base(2,4,4).

base(3,3,1).
base(3,3,3).
base(3,4,2).
base(3,4,3).
base(3,4,4).

base(4,4,2).
base(4,4,3).
base(4,4,4).

rep.
rep:-rep.


